## mingw-w64-vtk-9.3.1-5.src.tar.zst

=== Examples/ImageProcessing/Cxx/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8...3.12 FATAL_ERROR)
project(ImageProcessing)

include(GNUInstallDirs)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR}")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}")

find_package(VTK
  COMPONENTS
    CommonSystem
    IOImage
    ImagingFourier
    ImagingGeneral
    ImagingSources
    ImagingStatistics
    ImagingStencil
    InteractionStyle
    RenderingCore
    RenderingOpenGL2
    vtksys
  OPTIONAL_COMPONENTS
    TestingCore
    TestingRendering)
if (NOT VTK_FOUND)
  message("Skipping example: ${VTK_NOT_FOUND_MESSAGE}")
  return ()
endif ()

add_executable(ImageSlicing MACOSX_BUNDLE
  ImageSlicing.cxx)
target_link_libraries(ImageSlicing
  PRIVATE
    ${VTK_LIBRARIES})

add_executable(ImageBenchmark
  ImageBenchmark.cxx)
target_link_libraries(ImageBenchmark
  PRIVATE
    ${VTK_LIBRARIES})

add_executable(ImageBenchmarkDriver
  ImageBenchmarkDriver.cxx)
target_link_libraries(ImageBenchmarkDriver
  PRIVATE
    ${VTK_LIBRARIES})

vtk_module_autoinit(
  TARGETS ImageSlicing
          ImageBenchmark
          ImageBenchmarkDriver
  MODULES ${VTK_LIBRARIES})

if (BUILD_TESTING)
  include(CTest)
  if (TARGET VTK::TestingRendering)
    ######## Regression Testing ########
    set(ExternalData_BINARY_ROOT ${CMAKE_CURRENT_BINARY_DIR}/ExternalData)

    list(APPEND ExternalData_URL_TEMPLATES
      # Data published by Girder
      "https://data.kitware.com/api/v1/file/hashsum/%(algo)/%(hash)/download"

      # Data published by developers using git-gitlab-push.
      "https://www.vtk.org/files/ExternalData/%(algo)/%(hash)"
    )
    include(ExternalData)

    ExternalData_add_test(ImageProcessingData
      NAME    "ImageProcessingExampleCxx-ImageBenchmark"
      COMMAND ImageBenchmark
              --threads 2
              --filter resize:kernelsize=4
      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

    # FIXME: This test doesn't exit.
    if (FALSE)
      ExternalData_Expand_Arguments(ImageProcessingData _
        DATA{${CMAKE_CURRENT_SOURCE_DIR}/Testing/Data/headsq/,REGEX:.*})

      ExternalData_add_test(ImageProcessingData
        NAME    "ImageProcessingExampleCxx-ImageSlicing"
        COMMAND ImageSlicing
                ${CMAKE_CURRENT_BINARY_DIR}/ExternalData/Testing/Data/headsq/quarter
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    endif ()

    ExternalData_Add_Target(ImageProcessingData)
  endif ()
endif ()

=== Common/DataModel/Testing/Cxx/CMakeLists.txt ===
set(memkind_tests)
if(VTK_USE_MEMKIND)
  set(memkind_tests
    TestMemkindData.cxx
    )
endif()

vtk_add_test_cxx(vtkCommonDataModelCxxTests tests
  NO_DATA NO_VALID NO_OUTPUT
  ${memkind_tests}
  LagrangeHexahedron.cxx
  BezierInterpolation.cxx
  CellTreeLocator.cxx
  TestBezier.cxx
  TestAngularPeriodicDataArray.cxx
  TestArrayListTemplate.cxx
  TestCellInflation.cxx
  TestColor.cxx
  TestCoordinateFrame.cxx
  TestVector.cxx
  TestVectorOperators.cxx
  TestAMRBox.cxx
  TestBiQuadraticQuad.cxx
  TestCellArray.cxx
  TestCellArrayTraversal.cxx
  TestCompositeDataSets.cxx
  TestCompositeDataSetRange.cxx
  TestComputeBoundingSphere.cxx
  TestDataAssembly.cxx
  TestDataAssemblyUtilities.cxx
  TestDataObject.cxx
  TestDataObjectTreeRange.cxx
  TestFieldList.cxx
  TestGenericCell.cxx
  TestGraph.cxx
  TestGraph2.cxx
  TestGraphAttributes.cxx
  TestHigherOrderCell.cxx
  TestHyperTreeGridBitmask.cxx
  TestHyperTreeGridCursors.cxx
  TestHyperTreeGridElderChildIndex.cxx
  TestImageDataFindCell.cxx
  TestImageDataInterpolation.cxx
  TestImageDataOrientation.cxx
  TestImageIterator.cxx
  TestInformationDataObjectKey.cxx
  TestInterpolationDerivs.cxx
  TestInterpolationFunctions.cxx
  TestMappedGridDeepCopy.cxx
  TestMappedGridShallowCopy.cxx
  TestPath.cxx
  TestPentagonalPrism.cxx
  TestPiecewiseFunction.cxx
  TestPiecewiseFunctionLogScale.cxx
  TestPixelExtent.cxx
  TestPointLocators.cxx
  TestPolyDataRemoveCell.cxx
  TestPolygon.cxx
  TestPolygonBoundedTriangulate.cxx
  TestPolygonNormalOverflow.cxx
  TestPolyhedron0.cxx
  TestPolyhedron1.cxx
  TestPolyhedron3.cxx
  TestPolyhedronCombinatorialContouring.cxx
  TestPolyhedronConvexity.cxx
  TestPolyhedronConvexityMultipleCells.cxx
  TestPolyhedronTriangulateFaces.cxx
  TestPyramid.cxx
  TestQuadraticPolygon.cxx
  TestRect.cxx
  TestSMPFeatures.cxx
  TestSelectionExpression.cxx
  TestSelectionSubtract.cxx
  TestSimpleIncrementalOctreePointLocator.cxx
  TestSortFieldData.cxx
  TestStaticCellLocator.cxx
  TestTable.cxx
  TestThreadedCopy.cxx
  TestTreeBFSIterator.cxx
  TestTreeDFSIterator.cxx
  TestTriangle.cxx
  TestTetra.cxx
  TimePointLocators.cxx
  otherCellBoundaries.cxx
  otherCellPosition.cxx
  otherCellTypes.cxx
  otherColorTransferFunction.cxx
  otherEmptyCell.cxx
  otherFieldData.cxx
  otherImageData.cxx
  otherPolyData.cxx
  otherRectilinearGrid.cxx
  otherStructuredGrid.cxx
  otherUniformGrid.cxx
  otherUnstructuredGrid.cxx
  quadCellConsistency.cxx
  quadraticEvaluation.cxx
  TestBoundingBox.cxx
  TestPlane.cxx
  TestStaticCellLinks.cxx
  TestStructuredData.cxx
  TestDataObjectTypes.cxx
  TestPolyDataRemoveDeletedCells.cxx
  UnitTestCells.cxx
  UnitTestImplicitDataSet.cxx
  UnitTestImplicitVolume.cxx
  UnitTestLine.cxx
  UnitTestPlanesIntersection.cxx
  UnitTestTriangleIntersection.cxx
  TestHyperTreeGridGeometricLocator.cxx
  )
vtk_add_test_cxx(vtkCommonDataModelCxxTests data_tests
  TestImageDataOrientation2.cxx,NO_DATA
  TestLagrangeCurveNonLinearLevel.cxx,NO_DATA
  TestLagrangeTriangle.cxx
  TestLagrangeTetra.cxx
  TestLagrangeWedge.cxx
  quadraticIntersection.cxx
  TestCellIterators.cxx,NO_VALID,NO_OUTPUT
  TestCellLocator.cxx,NO_DATA
  TestIncrementalOctreePointLocator.cxx,NO_VALID
  TestMeanValueCoordinatesInterpolation1.cxx
  TestMeanValueCoordinatesInterpolation2.cxx
  TestPolyhedron4.cxx,NO_VALID,NO_OUTPUT
  TestPolyhedronDecompose.cxx,NO_DATA
  TestSmoothErrorMetric.cxx
  TestQuadraticPolygonFilters.cxx
  )
# add to the list but don't define a test
list(APPEND data_tests
  TestCellLocatorsEdgeCases.cxx
  TestPolyhedron2.cxx
  TestPolyhedronContouring.cxx
  TestPolyhedronCutter.cxx
  TestStaticCellLocatorEdgeCases.cxx
  )

vtk_add_test_cxx(vtkCommonDataModelCxxTests output_tests
  TestKdTreeRepresentation.cxx,NO_DATA
  )
ExternalData_add_test(${_vtk_build_TEST_DATA_TARGET}
  NAME VTK::CommonDataModelCxxTests-TestCellLocatorsEdgeCases
  COMMAND vtkCommonDataModelCxxTests TestCellLocatorsEdgeCases
  DATA{../Data/test_surface.vtp} DATA{../Data/cone.vtp}
  )
ExternalData_add_test(${_vtk_build_TEST_DATA_TARGET}
  NAME VTK::CommonDataModelCxxTests-TestPolyhedron2
  COMMAND vtkCommonDataModelCxxTests TestPolyhedron2
  -D DATA{../Data/polyhedron_mesh.vtu}
  )
ExternalData_add_test(${_vtk_build_TEST_DATA_TARGET}
  NAME VTK::CommonDataModelCxxTests-TestPolyhedronContouring
  COMMAND vtkCommonDataModelCxxTests TestPolyhedronContouring
   DATA{../Data/cell_850113.vtu} DATA{../Data/cell_12851_26.vtu}
  )
ExternalData_add_test(${_vtk_build_TEST_DATA_TARGET}
  NAME VTK::CommonDataModelCxxTests-TestPolyhedronCutter
  COMMAND vtkCommonDataModelCxxTests TestPolyhedronCutter
  DATA{../Data/onePolyhedron.vtu} DATA{../Data/sliceOfPolyhedron.vtu}
  )
ExternalData_add_test(${_vtk_build_TEST_DATA_TARGET}
  NAME VTK::CommonDataModelCxxTests-TestStaticCellLocatorEdgeCases
  COMMAND vtkCommonDataModelCxxTests TestStaticCellLocatorEdgeCases
  DATA{../Data/test_surface.vtp}
  )

set(all_tests
  ${tests}
  ${data_tests}
  ${output_tests}
  ${custom_tests}
  )
vtk_test_cxx_executable(vtkCommonDataModelCxxTests all_tests)

=== Filters/Geometry/Testing/Cxx/CMakeLists.txt ===
vtk_add_test_cxx(vtkFiltersGeometryCxxTests tests
  TestDataSetRegionSurfaceFilter.cxx
  TestDataSetSurfaceFieldData.cxx,NO_VALID
  TestDataSetSurfaceFilterQuadraticTetsGhostCells.cxx,NO_VALID
  TestDataSetSurfaceFilterWith1DGrids.cxx,NO_VALID
  TestDataSetSurfaceFilterWithBlankedImageData.cxx
  TestExplicitStructuredGridSurfaceFilter.cxx
  TestExtractSurfaceNonLinearSubdivision.cxx
  TestFastUnstructuredGridWithPolyDataGeometryFilter.cxx,NO_DATA
  TestImageDataToUniformGrid.cxx,NO_VALID
  TestLinearToQuadraticCellsFilter.cxx
  TestProjectSphereFilter.cxx,NO_VALID
  TestRecoverGeometryWireframe.cxx
  TestRegularGridDataSetSurfaceFilter.cxx
  TestStructuredAMRNeighbor.cxx,NO_VALID
  TestUnstructuredGridGeometryFilter.cxx
  )
vtk_add_test_cxx(vtkFiltersGeometryCxxTests no_data_tests
  NO_DATA NO_VALID NO_OUTPUT
  TestGeometryFilterCellData.cxx
  TestMappedUnstructuredGrid.cxx
  TestStructuredAMRGridConnectivity.cxx
  TestStructuredGridConnectivity.cxx
  UnitTestDataSetSurfaceFilter.cxx
  UnitTestProjectSphereFilter.cxx
  )

set(all_tests
  ${tests}
  ${no_data_tests}
  )
vtk_test_cxx_executable(vtkFiltersGeometryCxxTests all_tests)

=== Filters/Parallel/Testing/Cxx/CMakeLists.txt ===
vtk_add_test_cxx(vtkFiltersParallelCxxTests testsStd
  TestAlignImageDataSetFilter.cxx,NO_VALID
  TestAngularPeriodicFilter.cxx
  TestPOutlineFilter.cxx,NO_VALID
  )
vtk_test_cxx_executable(vtkFiltersParallelCxxTests testsStd)

if (TARGET VTK::ParallelMPI)
  set(vtkFiltersParallelCxxTests-MPI_NUMPROCS 2)
  vtk_add_test_mpi(vtkFiltersParallelCxxTests-MPI tests
    TESTING_DATA
    DistributedData.cxx
    DistributedDataRenderPass.cxx
    PTextureMapToSphere.cxx
    TestPHyperTreeGridProbeFilter.cxx
    TestPExtractDataArraysOverTime.cxx,NO_VALID
    TestPartitionBalancer.cxx,NO_VALID
    TransmitImageData.cxx
    TransmitImageDataRenderPass.cxx
    TransmitRectilinearGrid.cxx
    TransmitStructuredGrid.cxx
    )
  vtk_add_test_mpi(vtkFiltersParallelCxxTests-MPI no_data_tests
    ParallelResampling.cxx
    UnitTestPMaskPoints.cxx
    TestGenerateProcessIds.cxx,NO_VALID
    TestPOutlineFilter.cxx,NO_VALID
    TestHyperTreeGridGhostCellsGenerator.cxx,NO_VALID
    )

  # We want 4 processes to test the vtkAggregateDataSetFilter
  # properly
  set(vtkFiltersParallelCxxTests-MPI_NUMPROCS 4)
  vtk_add_test_mpi(vtkFiltersParallelCxxTests-MPI no_data_tests_4_procs
    AggregateDataSet.cxx
    )


  set(all_tests
    ${tests}
    ${no_data_tests}
    ${no_data_tests_4_procs}
    )
  vtk_test_cxx_executable(vtkFiltersParallelCxxTests-MPI all_tests)
endif()

=== ThirdParty/vtkm/vtkvtkm/vtk-m/examples/CMakeLists.txt ===
##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================

if(VTKm_ENABLE_EXAMPLES)
  # VTKm examples expects vtkm libraries to be namespaced with the prefix vtkm::.
  # However as the examples are also built as just another part of the VTK-m code
  # those prefix are not added to the targets (This happens during the
  # installation). To workaround this issue here, we create IMPORTED libs linking
  # to the vtkm libraries used by the examples with expected the vtkm:: prefix.
  vtkm_module_get_list(module_list)
  foreach(tgt IN LISTS module_list)
    if(TARGET ${tgt})
      # The reason of creating this phony IMPORTED libraries instead of making
      # ALIAS libraries is that ALIAS libraries are GLOBAL whereas IMPORTED are
      # local at the directory level where they are created. We do not want these
      # phony targets to be visible outside of the example directory.
      vtkm_target_mangle(tgt_name_mangled ${tgt})
      add_library("vtkm::${tgt_name_mangled}" INTERFACE IMPORTED)
      target_link_libraries("vtkm::${tgt_name_mangled}" INTERFACE ${tgt})
    endif()
  endforeach()

  #add the directory that contains the VTK-m config file to the cmake
  #path so that our examples can find VTK-m
  set(CMAKE_PREFIX_PATH ${VTKm_BINARY_DIR}/${VTKm_INSTALL_CONFIG_DIR})
  add_subdirectory(clipping)
  add_subdirectory(contour_tree)
  add_subdirectory(contour_tree_augmented)
  add_subdirectory(contour_tree_distributed)
  add_subdirectory(cosmotools)
  add_subdirectory(demo)
  add_subdirectory(game_of_life)
  add_subdirectory(hello_worklet)
  add_subdirectory(histogram)
  add_subdirectory(ising)
  add_subdirectory(lagrangian)
  add_subdirectory(logistic_map)
  add_subdirectory(mesh_quality)
  add_subdirectory(multi_backend)
  add_subdirectory(oscillator)
  add_subdirectory(particle_advection)
  add_subdirectory(streamline_mpi)
  add_subdirectory(polyline_archimedean_helix)
  add_subdirectory(redistribute_points)
  add_subdirectory(temporal_advection)
  add_subdirectory(tetrahedra)
  add_subdirectory(smoke_test)
endif()

if (VTKm_ENABLE_TESTING)
  # These need to be fast to build as they will
  # be built each time we run the test
  vtkm_test_against_install(demo)
  vtkm_test_against_install(histogram)
  vtkm_test_against_install(smoke_test)
endif()

=== ThirdParty/vtkm/vtkvtkm/vtk-m/examples/game_of_life/CMakeLists.txt ===
##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================
cmake_minimum_required(VERSION 3.12...3.15 FATAL_ERROR)
project(GameOfLife CXX)

#Find the VTK-m package
find_package(VTKm REQUIRED QUIET)
vtkm_find_gl(OPTIONAL GL GLUT GLEW)

if(TARGET OpenGL::GL AND
   TARGET GLUT::GLUT AND
   TARGET GLEW::GLEW)

  add_executable(GameOfLife GameOfLife.cxx LoadShaders.h)
  target_link_libraries(GameOfLife PRIVATE vtkm::filter_core OpenGL::GL GLEW::GLEW GLUT::GLUT)
  vtkm_add_target_information(GameOfLife
                              DROP_UNUSED_SYMBOLS MODIFY_CUDA_FLAGS
                              DEVICE_SOURCES GameOfLife.cxx)
endif()

=== ThirdParty/vtkm/vtkvtkm/vtk-m/vtkm/filter/mesh_info/CMakeLists.txt ===
##============================================================================
##  Copyright (c) Kitware, Inc.
##  All rights reserved.
##  See LICENSE.txt for details.
##
##  This software is distributed WITHOUT ANY WARRANTY; without even
##  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
##  PURPOSE.  See the above copyright notice for more information.
##============================================================================
set(mesh_info_headers
  CellMeasures.h
  GhostCellClassify.h
  MeshQuality.h
  MeshQualityArea.h
  MeshQualityAspectGamma.h
  MeshQualityAspectRatio.h
  MeshQualityCondition.h
  MeshQualityDiagonalRatio.h
  MeshQualityDimension.h
  MeshQualityJacobian.h
  MeshQualityMaxAngle.h
  MeshQualityMaxDiagonal.h
  MeshQualityMinAngle.h
  MeshQualityMinDiagonal.h
  MeshQualityOddy.h
  MeshQualityRelativeSizeSquared.h
  MeshQualityScaledJacobian.h
  MeshQualityShape.h
  MeshQualityShapeAndSize.h
  MeshQualityShear.h
  MeshQualitySkew.h
  MeshQualityStretch.h
  MeshQualityTaper.h
  MeshQualityVolume.h
  MeshQualityWarpage.h
  )

set(mesh_info_sources
  CellMeasures.cxx
  GhostCellClassify.cxx
  MeshQuality.cxx
  MeshQualityArea.cxx
  MeshQualityAspectGamma.cxx
  MeshQualityAspectRatio.cxx
  MeshQualityCondition.cxx
  MeshQualityDiagonalRatio.cxx
  MeshQualityDimension.cxx
  MeshQualityJacobian.cxx
  MeshQualityMaxAngle.cxx
  MeshQualityMaxDiagonal.cxx
  MeshQualityMinAngle.cxx
  MeshQualityMinDiagonal.cxx
  MeshQualityOddy.cxx
  MeshQualityRelativeSizeSquared.cxx
  MeshQualityScaledJacobian.cxx
  MeshQualityShape.cxx
  MeshQualityShapeAndSize.cxx
  MeshQualityShear.cxx
  MeshQualitySkew.cxx
  MeshQualityStretch.cxx
  MeshQualityTaper.cxx
  MeshQualityVolume.cxx
  MeshQualityWarpage.cxx
  )

vtkm_library(
  NAME vtkm_filter_mesh_info
  HEADERS ${mesh_info_headers}
  DEVICE_SOURCES ${mesh_info_sources}
  USE_VTKM_JOB_POOL
)

target_link_libraries(vtkm_filter PUBLIC INTERFACE vtkm_filter_mesh_info)

add_subdirectory(worklet)

=== PKGBUILD ===
# Maintainer: Sergey Popov <popov.sa@gmail.com>
# Contributor: Mario Emmenlauer <memmenlauer@biodataanalysis.de>

_realname=vtk
pkgbase="mingw-w64-${_realname}"
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=9.3.1
pkgrel=5
pkgdesc="A software system for 3D computer graphics, image processing and visualization (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.vtk.org/"
msys2_repository_url="https://gitlab.kitware.com/vtk/vtk"
msys2_references=(
  'archlinux: vtk'
  "cpe: cpe:/a:vtk:vtk"
)
license=("spdx:BSD-3-Clause")
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-double-conversion"
         "${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-fmt"
         "${MINGW_PACKAGE_PREFIX}-freetype"
         "${MINGW_PACKAGE_PREFIX}-glew"
         "${MINGW_PACKAGE_PREFIX}-tbb"
         "${MINGW_PACKAGE_PREFIX}-jsoncpp"
         "${MINGW_PACKAGE_PREFIX}-libharu"
         "${MINGW_PACKAGE_PREFIX}-libjpeg"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread-git"
         "${MINGW_PACKAGE_PREFIX}-lz4"
         "${MINGW_PACKAGE_PREFIX}-omp"
         "${MINGW_PACKAGE_PREFIX}-openxr-sdk"
         "${MINGW_PACKAGE_PREFIX}-pugixml"
         $([[ ${MSYSTEM} == MINGW64 ]] || echo "${MINGW_PACKAGE_PREFIX}-verdict")
         "${MINGW_PACKAGE_PREFIX}-xz"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-adios2"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-cgns"
             "${MINGW_PACKAGE_PREFIX}-cli11"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-fast_float"
             "${MINGW_PACKAGE_PREFIX}-ffmpeg"
             "${MINGW_PACKAGE_PREFIX}-fontconfig"
             "${MINGW_PACKAGE_PREFIX}-gdal"
             "${MINGW_PACKAGE_PREFIX}-gl2ps"
             "${MINGW_PACKAGE_PREFIX}-hdf5"
             "${MINGW_PACKAGE_PREFIX}-liblas"
             "${MINGW_PACKAGE_PREFIX}-libmariadbclient"
             "${MINGW_PACKAGE_PREFIX}-libpng"
             "${MINGW_PACKAGE_PREFIX}-libogg"
             "${MINGW_PACKAGE_PREFIX}-libtheora"
             "${MINGW_PACKAGE_PREFIX}-libxml2"
             "${MINGW_PACKAGE_PREFIX}-netcdf"
             "${MINGW_PACKAGE_PREFIX}-openslide"
             "${MINGW_PACKAGE_PREFIX}-opencascade"
             "${MINGW_PACKAGE_PREFIX}-openturns"
             "${MINGW_PACKAGE_PREFIX}-openvdb"
             "${MINGW_PACKAGE_PREFIX}-openvr"
             "${MINGW_PACKAGE_PREFIX}-pdal"
             # "${MINGW_PACKAGE_PREFIX}-pegtl" https://gitlab.kitware.com/vtk/vtk/-/issues/18151
             "${MINGW_PACKAGE_PREFIX}-postgresql"
             "${MINGW_PACKAGE_PREFIX}-proj"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-sqlite3"
             # "${MINGW_PACKAGE_PREFIX}-tk"
             "${MINGW_PACKAGE_PREFIX}-unixodbc"
             "${MINGW_PACKAGE_PREFIX}-utf8cpp"
             )
optdepends=("${MINGW_PACKAGE_PREFIX}-adios2: I/O ADIOS2"
            "${MINGW_PACKAGE_PREFIX}-boost: InfovisBoost and InfovisBoostGraphAlgorithms modules"
            "${MINGW_PACKAGE_PREFIX}-cgns: CGNS Reader"
            "${MINGW_PACKAGE_PREFIX}-ffmpeg: I/O FFMPEG"
            "${MINGW_PACKAGE_PREFIX}-fontconfig: Fontconfig Rendering"
            "${MINGW_PACKAGE_PREFIX}-gdal: I/O GDAL"
            "${MINGW_PACKAGE_PREFIX}-gl2ps: PS Rendering"
            "${MINGW_PACKAGE_PREFIX}-hdf5: I/O HDF5"
            "${MINGW_PACKAGE_PREFIX}-liblas: I/O LAS"
            "${MINGW_PACKAGE_PREFIX}-libmariadbclient: I/O MySQL/MariaDB"
            "${MINGW_PACKAGE_PREFIX}-libpng: I/O Images"
            "${MINGW_PACKAGE_PREFIX}-libogg: I/O OGG and Theora"
            "${MINGW_PACKAGE_PREFIX}-libtheora: I/O OGG and Theora"
            "${MINGW_PACKAGE_PREFIX}-libxml2: I/O Infovis"
            "${MINGW_PACKAGE_PREFIX}-netcdf: I/O netCDF"
            "${MINGW_PACKAGE_PREFIX}-opencascade: I/O OCCT"
            "${MINGW_PACKAGE_PREFIX}-openslide: DomainsMicroscopy"
            "${MINGW_PACKAGE_PREFIX}-openturns"
            "${MINGW_PACKAGE_PREFIX}-openvdb: I/O OpenVDB"
            "${MINGW_PACKAGE_PREFIX}-openvr: OpenVR Rendering"
            "${MINGW_PACKAGE_PREFIX}-pdal: I/O PDAL"
            "${MINGW_PACKAGE_PREFIX}-postgresql: I/O PostgreSQL"
            "${MINGW_PACKAGE_PREFIX}-proj: GEOVis"
            "${MINGW_PACKAGE_PREFIX}-python: Python bindings"
            "${MINGW_PACKAGE_PREFIX}-python-matplotlib: Matplotlib renderer"
            "${MINGW_PACKAGE_PREFIX}-qt6-base: Qt Rendering"
            "${MINGW_PACKAGE_PREFIX}-qt6-declarative: Qt Qml plugin"
            "${MINGW_PACKAGE_PREFIX}-sqlite3: I/O SQL"
            # "${MINGW_PACKAGE_PREFIX}-tk: TCL bindings, Python Tk widgets"
            "${MINGW_PACKAGE_PREFIX}-unixodbc")
source=(https://www.vtk.org/files/release/${pkgver%.*}/VTK-${pkgver}.tar.gz
        "001-no-exact-version-for-fast_float.patch"
        "002-Fix-build-with-gcc-13.patch"
        "003-fix-build-with-fmt-11.patch"
        "004-accept-future-versions-of-boost-and-occ.patch"
        "007-dll-export-some-functions.patch"
        "008-Fix-vtkm_openmp-exported-target.patch")
sha256sums=('8354ec084ea0d2dc3d23dbe4243823c4bfc270382d0ce8d658939fd50061cab8'
            '411b0521fcd2864acae0af20ba6334f69f7c605c9e31996529f64aa749d61065'
            '20733e97ccf9b0a8e615c75936ce5e4c1db0ac00e9cac30bc359d5912da38990'
            '7c15ee91447c9199dafaa32eb3cf6afbf16e6306b7879a2dcd9f4ebc95c2e75e'
            'a44b3ba4bdc02be4767ff48b8a7fd4206a53756a881421fca99f538b08a7b48c'
            'a9b9292be90c259f0aa058e3f4a7a08b6218f20e6cb2a71e214acda2d2302a50'
            '988ef1d43dadf1da157fc69398f545c6d2e82d2dabd7cb830e9fba9ebaba34ac')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  apply_patch_with_msg \
    001-no-exact-version-for-fast_float.patch \
    002-Fix-build-with-gcc-13.patch \
    003-fix-build-with-fmt-11.patch \
    004-accept-future-versions-of-boost-and-occ.patch \
    008-Fix-vtkm_openmp-exported-target.patch

  # Succeed with Clang but failed with GCC!
  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    apply_patch_with_msg \
      007-dll-export-some-functions.patch
  fi
}

build() {
  mkdir -p ${srcdir}/build-${MSYSTEM} && cd ${srcdir}/build-${MSYSTEM}

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MSYSTEM} == MINGW64 ]]; then
    _extra_config+=("-DVTK_MODULE_USE_EXTERNAL_VTK_verdict=OFF")
  fi

  CFLAGS+=" ${CPPFLAGS}"
  CXXFLAGS+=" ${CPPFLAGS} -D_USE_MATH_DEFINES -Wno-attributes -Wno-ignored-attributes -Wno-deprecated-declarations"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -Wno-dev \
    -G"Ninja" \
    "${_extra_config[@]}" \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    -DCMAKE_INSTALL_LICENSEDIR=share/licenses/vtk \
    -DBUILD_SHARED_LIBS=ON \
    -DPython3_EXECUTABLE="${MINGW_PREFIX}/bin/python.exe" \
    -DVTK_BUILD_TESTING=OFF \
    -DVTK_VERSIONED_INSTALL=OFF \
    -DVTK_BUILD_ALL_MODULES=ON \
    -DVTK_GROUP_ENABLE_MPI=NO \
    -DVTK_GROUP_ENABLE_Web=NO \
    -DVTK_MODULE_ENABLE_VTK_RenderingOpenXRRemoting=NO \
    -DVTK_MODULE_ENABLE_VTK_RenderingZSpace=NO \
    -DVTK_USE_EXTERNAL=ON \
    -DVTK_MODULE_USE_EXTERNAL_VTK_exprtk=OFF \
    -DVTK_MODULE_USE_EXTERNAL_VTK_ioss=OFF \
    -DVTK_MODULE_USE_EXTERNAL_VTK_pegtl=OFF \
    -DVTK_WRAP_JAVA=OFF \
    -DVTK_WRAP_PYTHON=ON \
    -DVTK_SMP_IMPLEMENTATION_TYPE=TBB \
    -DVTK_SMP_ENABLE_SEQUENTIAL=ON \
    -DVTK_SMP_ENABLE_STDTHREAD=ON \
    -DVTK_SMP_ENABLE_OPENMP=ON \
    -DVTK_USE_VIDEO_FOR_WINDOWS=ON \
    -DVTK_ENABLE_OSPRAY=OFF \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/Copyright.txt" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"

  # Remove third party CMake patching for older versions than ours
  rm -rv "${pkgdir}"${MINGW_PREFIX}/lib/cmake/vtk/patches/3.{1{3,6,9},2{0,2,3}}
  # … as well as duplicate copies
  rm -rv "${pkgdir}"${MINGW_PREFIX}/lib/cmake/vtk/vtkm/{Find*.cmake,cmake/{Find*.cmake,3.15}}

}
